package com.scalangular.f1.league.v2.usecases.crud

import arrow.core.Either
import arrow.core.getOrElse
import com.scalangular.f1.league.v2.entities.DriverRaceResult
import com.scalangular.f1.league.v2.entities.F1Driver
import com.scalangular.f1.league.v2.entities.League
import com.scalangular.f1.league.v2.entities.Race
import com.scalangular.f1.league.v2.generated.transfer.entitys.F1Circuit
import com.scalangular.f1.league.v2.generated.transfer.entitys.F1RaceResultStatus
import com.scalangular.f1.league.v2.generated.transfer.entitys.RaceResult
import com.scalangular.f1.league.v2.ports.output.DefaultLeagueExistsPort
import com.scalangular.f1.league.v2.repositories.DriverRaceResultRepository
import com.scalangular.f1.league.v2.repositories.DriverRepository
import com.scalangular.f1.league.v2.repositories.LeagueRepository
import com.scalangular.f1.league.v2.repositories.RaceRepository
import com.scalangular.f1.league.v2.usecases.common.DefaultAutogenerateDNSForRaceResultUseCase
import com.scalangular.f1.league.v2.usecases.common.DefaultBuildRaceResultsUseCase
import com.scalangular.f1.league.v2.usecases.crud.GetRaceResultsUseCase.GetRaceResultsCommand.GetRaceResultsForDriverCommand
import com.scalangular.f1.league.v2.usecases.crud.GetRaceResultsUseCase.GetRaceResultsError
import com.scalangular.f1.league.v2.usecases.crud.GetRaceResultsUseCase.GetRaceResultsError.DriverNotFoundError
import com.scalangular.f1.league.v2.usecases.crud.GetRaceResultsUseCase.GetRaceResultsError.LeagueNotFoundError
import io.kotest.assertions.arrow.core.shouldBeLeft
import io.kotest.assertions.arrow.core.shouldBeRight
import io.kotest.assertions.assertSoftly
import io.kotest.core.spec.style.StringSpec
import io.kotest.extensions.spring.SpringExtension
import io.kotest.matchers.collections.shouldNotBeEmpty
import io.kotest.matchers.shouldBe
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest
import org.springframework.boot.test.autoconfigure.orm.jpa.TestEntityManager
import java.time.LocalDateTime
import java.util.*
import kotlin.random.Random

@DataJpaTest
class DefaultGetRaceResultsUseCaseTest(
    val entityManager: TestEntityManager,
    driverRepository: DriverRepository,
    raceRepository: RaceRepository,
    leagueRepository: LeagueRepository,
    driverRaceResultRepository: DriverRaceResultRepository,
) : StringSpec({
    val getRaceResultsUseCase = DefaultGetRaceResultsUseCase(
        DefaultGetRacesUseCase(raceRepository),
        driverRepository,
        DefaultLeagueExistsPort(leagueRepository),
        raceRepository,
        driverRaceResultRepository,
        DefaultBuildRaceResultsUseCase(),
        DefaultAutogenerateDNSForRaceResultUseCase()
    )

    fun generateRace(savedLeague: League): Race {
        return Race(
            circuit = F1Circuit.ABUDHABI,
            raceId = null,
            racePositionIndex = 1,
            raceDate = LocalDateTime.now(),
            league = savedLeague
        )
    }

    fun generateDriverRaceResult(savedF1Driver: F1Driver, savedRace: Race): DriverRaceResult {
        return DriverRaceResult(
            race = savedRace,
            driverRaceResultId = null,
            endPosition = 1,
            drivenLaps = 70,
            bestLapTime = 121f,
            totalRaceTime = 21312.21,
            penaltiesAmount = 1,
            penaltiesTime = 3f,
            pitStops = 1,
            f1Driver = savedF1Driver,
            raceNumber = 3,
            raceResultStatus = F1RaceResultStatus.finished,
            gridPosition = 2
        )
    }

    fun generateDriver(league: League): F1Driver {
        return F1Driver(
            driverId = null,
            name = "Moritz",
            surename = "Lindner",
            carNumber = Random(12131).nextInt(),
            league = league
        )
    }

    "get race results for a driver" {
        val league = League(
            "myLeague",
            null
        )
        val savedLeague: League = entityManager.persistAndFlush(league)
        val savedDriver = entityManager.persist(generateDriver(savedLeague))

        val command = GetRaceResultsForDriverCommand(
            savedLeague.leagueId ?: UUID.randomUUID(),
            savedDriver.driverId ?: UUID.randomUUID()
        )

        List(10) {
            val savedRace = entityManager.persistAndFlush(generateRace(savedLeague))
            entityManager.persistAndFlush(generateDriverRaceResult(savedDriver, savedRace))
        }

        val result: Either<GetRaceResultsError, List<RaceResult>> =
            getRaceResultsUseCase.getRaceResults(command)

        assertSoftly(result) {
            shouldBeRight()
            getOrElse { emptyList() }.shouldNotBeEmpty()
        }
    }

    "get race results for a unknown driver results in DriverNotFoundError" {
        val league = League(
            "myLeague",
            null
        )
        val savedLeague: League = entityManager.persistAndFlush(league)

        val command = GetRaceResultsForDriverCommand(
            savedLeague.leagueId ?: UUID.randomUUID(),
            UUID.randomUUID()
        )

        val result: Either<GetRaceResultsError, List<RaceResult>> =
            getRaceResultsUseCase.getRaceResults(command)

        result.shouldBeLeft().shouldBe(DriverNotFoundError)
    }

    "get race results for a unknown league results in LeagueNotFound" {
        val command = GetRaceResultsForDriverCommand(
            UUID.randomUUID(),
            UUID.randomUUID()
        )

        val result: Either<GetRaceResultsError, List<RaceResult>> =
            getRaceResultsUseCase.getRaceResults(command)

        result.shouldBeLeft().shouldBe(LeagueNotFoundError)
    }
}
) {
    override fun extensions() = listOf(SpringExtension)
}
